#include <applicat.h>
#include <mask.h>
#include <config.h>
#include <utility.h>
#include <execp.h>
#include <isam.h>

#include "bainst.h"
#include "bainst11.h"

class TInstall_CE : public TSkeleton_application
{
protected:
  virtual void main_loop() ;
  virtual bool install_com(bool in_lire) ; // setta i dati comuni
 
public:
  virtual ~TInstall_CE () {}
};

bool TInstall_CE ::install_com(bool in_lire) 
{   
  const char* tab[5] = {"cac","cat","cgr","tmc","clm"};
  if (in_lire)
    tab[4] = "clm_lire";
  
  TSystemisamfile tabcom(LF_TABCOM);
  TStd_filename txtfile;
  TString16 str;
  for (int i=0; i<5; i++)
  {            
    str = tab[i]; str << ".txt";
    txtfile.check(FALSE, str);
    tabcom.load(txtfile);
  }
  return TRUE;
}

void TInstall_CE::main_loop() 
{
  TConfig ini("install.ini","ce");
  const bool primainst=ini.get("Versione").blank();

  TMask m("bainst11.msk");
  if (primainst)
    m.set(F_LOADTAB,"X");
  if (m.run()!=K_QUIT && m.get_bool(F_LOADTAB))
  { 
    bool in_lire = m.get_bool(F_LIMITI);
    install_com(in_lire);
  }
}

int bainst11(int argc, char** argv)
{ 
  TInstall_CE app;
  app.run(argc, argv, "Installazione Cespiti");
  return 0;
}